#include "BlankCell.h"

BlankCell::BlankCell()
{
}

bool
BlankCell::hasConnector(Direction) const
{
	return false;
}

void
BlankCell::paint(QPainter &paint)
{
	Cell *cell[4];

	for (int i = 0; i < NUM_DIRECTIONS; i++)
		cell[i] = getBoard()->getNearCell(this, (Direction)i);

	paint.setPen(QColor(0, 0, 0));

	if (getY() > 0 &&
		cell[NORTH] != NULL &&
		cell[NORTH]->getType() != Cell::BLANK)
	{
		paint.drawLine(-1, -1, WIDTH - 1, -1);
		paint.setPen(QColor(164, 164, 164));
		paint.drawLine(0, 0, WIDTH, 0);
		paint.setPen(QColor(0, 0, 0));
	}

	if (getX() > 0 &&
		cell[WEST] != NULL &&
		cell[WEST]->getType() != Cell::BLANK)
	{
		paint.drawLine(-1, -1, -1, HEIGHT - 1);
		paint.setPen(QColor(164, 164, 164));
		paint.drawLine(0, 0, 0, HEIGHT);
		paint.setPen(QColor(0, 0, 0));
	}

	if (getX() < getBoard()->getWidth() - 1 &&
		cell[EAST] != NULL &&
		cell[EAST]->getType() != Cell::BLANK)
	{
		paint.drawLine(WIDTH - 1, -1, WIDTH - 1, HEIGHT - 1);
	}

	if (getY() < getBoard()->getHeight() - 1 &&
		cell[SOUTH] != NULL &&
		cell[SOUTH]->getType() != Cell::BLANK)
	{
		paint.drawLine(-1, HEIGHT - 1, WIDTH - 1, HEIGHT - 1);
	}
}
