#ifndef _TICKYPIP_CELL_H_
#define _TICKYPIP_CELL_H_

#include "Direction.h"

#include <qpainter.h>

class Board;

class Cell
{
	public:
		enum CellType { CONNECTOR, COMPUTER, SERVER, BLANK, WIRELESS };

		enum { WIDTH = 20, HEIGHT = 20 };

		Cell();
		virtual ~Cell() {}

		virtual CellType getType() const = 0;

		void setX(size_t x);
		void setY(size_t y);
		size_t getX() const;
		size_t getY() const;

		void setBoard(Board *board);
		Board *getBoard() const;

		void rotateRight();
		void rotateLeft();

		virtual void setDirection(Direction dir);
		Direction getDirection() const;

		virtual bool isConnectedWith(const Cell *cell) const;
		virtual bool hasConnector(Direction dir) const = 0;

		virtual bool isActive() const;

		virtual void paint(QPainter &paint);

	protected:
		void setSource(Direction dir, bool source);
		bool isSource(Direction dir);

		virtual void activeChanged() {}

	private:
		Direction dir;
		bool activeSources[NUM_DIRECTIONS];
		size_t sourceCount;

		Board *board;
		size_t x, y;
};

#include "Board.h"

#endif /* _TICKYPIP_CELL_H_ */
