#include "ComputerCell.h"

#include <qpe/resource.h>
#include <qpixmap.h>

ComputerCell::ComputerCell()
	: ConnectorCell()
{
	setConnectorType(CONNECTOR_END);
}

void
ComputerCell::paint(QPainter &paint)
{
	static QPixmap pixmap;
	static QPixmap pixmapActive;
	static bool pixmapsLoaded = false;

	ConnectorCell::paint(paint);

	if (!pixmapsLoaded)
	{
		pixmapActive = Resource::loadPixmap("tickypip/computer_active");
		pixmap       = Resource::loadPixmap("tickypip/computer");

		pixmapsLoaded = true;
	}

	if (isActive())
		paint.drawPixmap(0, 0, pixmapActive);
	else
		paint.drawPixmap(0, 0, pixmap);
}

void
ComputerCell::activeChanged()
{
	if (isActive())
		getBoard()->incNumComputers();
	else
		getBoard()->decNumComputers();
}
