#ifndef _TICKYPIP_CONNECTORCELL_H_
#define _TICKYPIP_CONNECTORCELL_H_

#include "Cell.h"

class ConnectorCell : public Cell
{
	public:
		typedef enum
		{
			CONNECTOR_NONE = 0,
			CONNECTOR_END,
			CONNECTOR_LINE,
			CONNECTOR_T,
			CONNECTOR_L,
			CONNECTOR_CROSS

		} ConnectorType;

		ConnectorCell();

		virtual CellType getType() const { return CONNECTOR; }

		virtual void setDirection(Direction dir);

		void setConnectorType(ConnectorType type);
		ConnectorType getConnectorType() const;

		virtual bool hasConnector(Direction dir) const;

		virtual void paint(QPainter &paint);

	protected:
		virtual void paintLine(QPainter &paint, Direction dir, bool d,
							   const QBrush &brush) const;

	private:
		enum { LINE_LEN = 10 };

		Direction connectorDir;
		ConnectorType type;

		bool dirConnectors[NUM_DIRECTIONS];
};

#include "base.h"


#endif /* _TICKYPIP_CONNECTORCELL_H_ */

