#include "Level.h"

Level::Level(Board *board)
	: board(board), title(QT_TR_NOOP("Unnamed")), numLevels(0)
{
}

Level::Level(QString &name, Board *board)
	: board(board), title(name), numLevels(0)
{
}

Level::~Level()
{
	f.close();
}

void
Level::setBoard(Board *board)
{
	this->board = board;
}

Board *
Level::getBoard() const
{
	return board;
}

QString
Level::getTitle() const
{
	return title;
}

size_t
Level::getNumLevels() const
{
	return numLevels;
}

bool
Level::loadLevelFile(const QString &filename)
{
	if (filename == "")
		return false;

	setNumLevels(0);

	f.setName(filename);

	if (!f.open(IO_ReadOnly))
		return false;

	if (!isValidFormat())
	{
		f.close();

		return false;
	}

	if (!readHeader())
	{
		f.close();

		return false;
	}

	return true;
}

void
Level::setTitle(const QString &title)
{
	this->title = title;
}

void
Level::setNumLevels(size_t num)
{
	this->numLevels = num;
}
