#ifndef _TICKYPIP_LEVEL_H_
#define _TICKYPIP_LEVEL_H_

#include <qfile.h>

class Board;

class Level
{
	public:
		Level(Board *board = NULL);
		Level(QString &name, Board *board = NULL);
		virtual ~Level();

		void setBoard(Board *board);
		Board *getBoard() const;

		QString getTitle() const;
		size_t getNumLevels() const;

		bool loadLevelFile(const QString &filename);

		virtual bool setupLevel(size_t level) = 0;

	protected:
		void setTitle(const QString &title);
		void setNumLevels(size_t num);

		virtual bool readHeader() { return true; }
		virtual bool isValidFormat() = 0;

	protected:
		QFile f;

	private:
		Board *board;
		QString title;
		size_t numLevels;
};

#include "base.h"

#endif /* _TICKYPIP_LEVEL_H_ */
