#ifndef _TICKYPIP_QTPBOARD_H_
#define _TICKYPIP_QTPBOARD_H_

#include "base.h"
#include <qframe.h>
#include <qpainter.h>

class Tickypip;

class QTPBoard : public QWidget, UpdateListener
{
	Q_OBJECT
	
	public:
		QTPBoard(QWidget *parent = NULL, const char *name = NULL,
				 Tickypip *tickypip = NULL);
		~QTPBoard();

		void loadLevel(const QString &filename, size_t num);

		void setBoard(Board *board);
		Board *getBoard() const;

		void clear();

		void cellUpdated(int x, int y, Cell *cell);

	protected:
		void resetSizes();

		void drawCell(QPainter &paint, Cell *cell);
		void drawCells(QPainter &paint);
		void drawBoard(QPainter &paint);

		virtual void paintEvent(QPaintEvent *evt);
		virtual void mousePressEvent(QMouseEvent *evt);

	private:
		int pos2index(int x) { return x / SCALE; }
		int index2pos(int i) { return i * SCALE; }

	private:
		enum
		{
			MIN_WIDTH  =  5,
			MIN_HEIGHT =  5,
			MAX_WIDTH  = 10,
			MAX_HEIGHT = 10,
			SCALE      = 20
		};

		Tickypip *tickypip;
		Board *board;
};

#endif /* _TICKYPIP_QTPBOARD_H_ */
