#ifndef _TICKYPIP_SERVERCELL_H_
#define _TICKYPIP_SERVERCELL_H_

#include "ConnectorCell.h"

class ServerCell : public ConnectorCell
{
	public:
		typedef enum { SERVER_TOP, SERVER_BOTTOM } ServerType;

		virtual CellType getType() const { return SERVER; }

		ServerCell(ServerType type);

		ServerType getServerType() const;

		void setDirection(Direction dir);
		bool isActive() const;

		bool hasConnector(Direction dir) const;

		void paint(QPainter &paint);

	protected:
		void ServerCell::paintLine(QPainter &paint, Direction dir,
								   bool d, const QBrush &brush) const;

	private:
		ServerType type;
		volatile bool dirLock, paintLock;
};

#include "base.h"


#endif /* _TICKYPIP_SERVERCELL_H_ */
