#ifndef _TICKYPIP_TPLEVEL_H_
#define _TICKYPIP_TPLEVEL_H_

#include "Level.h"

class QTextStream;
class ServerCell;

class TPLevel : public Level
{
	public:
		TPLevel(Board *board = NULL);

		bool setupLevel(size_t level);

	protected:
		bool readHeader();
		bool isValidFormat();
		void addCell(char cellType, char cellOptions, size_t x, size_t y);
		bool readLevelHeader(QTextStream &t, size_t &width,
							 size_t &height, bool &randomize);

		enum
		{
			CELL_BLANK     = '0',
			CELL_COMPUTER  = '1',
			CELL_CONNECTOR = '2',
			CELL_WIRELESS  = '3',
			CELL_SERVER    = '4'
		};

	private:
		ServerCell *topServerCell;
};

#endif /* _TICKYPIP_TPLEVEL_H_ */

